/*-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class              	G3DFunctions
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DFunctions.h,v 1.1 2002/10/12 17:24:32 probert Exp $
//
//---------------------------------------------------------------------------*/

#ifndef __G3DFunctions_h_INCLUDE
#define __G3DFunctions_h_INCLUDE

#include <GeometryKit/G3DDefs.h>

/******************************************************************************
 *
 * Some usefuls vectors and matrices
 *
 *****************************************************************************/

extern const float  G3DIdentityMatrix3f[9];
extern const double G3DIdentityMatrix3d[9];

extern const float  G3DIdentityMatrix4f[16];
extern const double G3DIdentityMatrix4d[16];

extern const float  G3DDefaultPlane4f[4];
extern const double G3DDefaultPlane4d[4];

/******************************************************************************
 *
 * Misc Functions 
 *
 *****************************************************************************/

/*
 * res = lambda * a + (1 - lambda) * b
 */

__G3DIE__ void G3DLinearInterpolateVector3fv(float res[3], CFLOAT a[3], 
                                             CFLOAT b[3], CFLOAT lambda);
__G3DIE__ void G3DLinearInterpolateVector3dv(double res[3], CDOUBLE a[3], 
                                             CDOUBLE b[3], CDOUBLE lambda);

/*
 *
 */

__G3DIE__ float  G3DDistanceFromPlanef(CFLOAT point[3],CFLOAT plane[4]);
__G3DIE__ double G3DDistanceFromPlaned(CDOUBLE point[3],CDOUBLE plane[4]);

__G3DIE__ int G3DIntersectLinePlanef(float isect[3], CFLOAT ldir[3], 
                                     CFLOAT lpos[3], CFLOAT plane[4]);

__G3DIE__ int G3DIntersectLinePlaned(double isect[3], CDOUBLE ldir[3], 
                                     CDOUBLE lpos[3], CDOUBLE plane[4]);

/*
 *
 */

__G3DIE__ int G3DCompareFloat(float a, float b, float tol);
__G3DIE__ int G3DCompareDouble(double a, double b, double tol);

/*
 *
 */

__G3DIE__ void G3DFloatsFromDoubles(float* dest, CDOUBLE *src, const int size);
__G3DIE__ void G3DDoublesFromFloats(double* dest, CFLOAT *src, const int size);

#endif









