//-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class		G3DVector4f
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector4f.h,v 1.1 2002/10/12 17:24:32 probert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector4f_h_INCLUDE
#define __G3DVector4f_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple4f.h>

@interface G3DVector4f : G3DTuple4f
{
}

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector4f *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector4f *)vectorByAdding:(G3DVector4f *)aVector;
- (G3DVector4f *)vectorBySubtracting:(G3DVector4f *)aVector;

- (G3DVector4f *)vectorByMultiplyingBy:(float)aScalar;
- (G3DVector4f *)vectorByDividingBy:(float)aScalar;

- (float)dotProduct:(G3DVector4f *)aVec;

- (float)length;

- (float)squaredLength;

- (void)normalise;

- (G3DVector4f *)normalisedVector;

@end

#endif







