#import <Foundation/Foundation.h>
#import <GeometryKit/G3DMatrix4d.h>
#import <GeometryKit/G3DDefs.h>
#import <GeometryKit/G3DFunctions.h>

int main()
{
  id pool;

  pool = [[NSAutoreleasePool alloc] init];

  {
    double vals[16] = {1,2,3,0,5,2,1,0,9,0,1,0,1,4,5,1};
    double vals2[16] = {1,0,0,0,0,2,0,0,0,0,3,0,0,0,0,4};
    double axis[3] = {1.0,0.0,1.0};

    G3DMatrix4d *m = [[G3DMatrix4d alloc] initWithElements:vals];

    NSLog(@"G3DMatrix4d Test Tool");

    // First matrix...
    NSLog([m description]);
    NSLog([NSString stringWithFormat:@"Determinante: %f",[m determinant]]);
    [m transpose];
    NSLog(@"Transposed matrix:");
    NSLog([m description]);

    // Second matrix...
    [m setElements:(double*)G3DIdentityMatrix4d];
    NSLog([m description]);
    NSLog([NSString stringWithFormat:@"Determinante: %f",[m determinant]]);
    if(![m invert]) {
      NSLog(@"Couldn't invert matrix");
    }
    else {
      NSLog(@"Inverted matrix:");
      NSLog([m description]);
    }

    // Third matrix...
    [m setElements:vals2];
    NSLog([m description]);
    NSLog([NSString stringWithFormat:@"Determinante: %f",[m determinant]]);

    if(![m invert]) {
      NSLog(@"Couldn't invert matrix");
    }
    else {
      NSLog(@"Inverted matrix:");
      NSLog([m description]);
    }

    // Some elements?!...
    NSLog([NSString stringWithFormat:@"Element 2,3: %f",[m elementAtRow:1 column:2]]);
    NSLog([NSString stringWithFormat:@"Element 4,3: %f",[m elementAtRow:3 column:2]]);

    // Make a rotation matrix...
    NSLog(@"Rotation with angle 45 and axis 1,0,1");
    [m setRotation:45.5 axis:axis];
    NSLog([m description]);
    NSLog([NSString stringWithFormat:@"Element 4,3: %f",[m elementAtRow:3 column:2]]);

    // Make a rotation matrix...
    NSLog(@"Rotation with angle 33.3 and axis 1,0,0");
    [m setXRotation:33.333];
    NSLog([m description]);
    // Make a rotation matrix...
    NSLog(@"Rotation with angle 33.3 and axis 0,1,0");
    [m setYRotation:33.333];
    NSLog([m description]);
    // Make a rotation matrix...
    NSLog(@"Rotation with angle 33.3 and axis 0,0,1");
    [m setZRotation:33.333];
    NSLog([m description]);

    NSLog(@"Done...");

    [m autorelease];
  }
  
  [pool release];
  exit(0);
}
