#import <Foundation/Foundation.h>
#import <GeometryKit/G3DFunctions.h>
#import <GeometryKit/G3DDefs.h>
#import <GeometryKit/G3DQuaternionf.h>

int main()
{
  id pool;

  pool = [[NSAutoreleasePool alloc] init];

  {
    float el[] = {1.0,2.0,1.0,1.5};
    float el2[] = {1.5,1.0,3.0,1.5};
    G3DQuaternionf *p = [[G3DQuaternionf alloc] initWithElements:el2];
    G3DQuaternionf *q = [[G3DQuaternionf alloc] initWithElements:el];
    G3DMatrix3f *m;
    G3DMatrix4f *m2;

    m = [q rotationMatrix3f];

    NSLog(@"*** G3DQuaternion Test Tool\n");

    NSLog(@"Quaternion: %@",[q description]);

    // Norm
    q = [q normalisedQuaternion];
    p = [p normalisedQuaternion];
    NSLog([NSString stringWithFormat:@"Normalised quaternion: %@",[q description]]);

    // First matrix...
    NSLog(@"3x3 Rotationmatrix:");
    NSLog([m description]);

    m2 = [q rotationMatrix4f];
    NSLog(@"4x4 Rotationmatrix:");
    NSLog([m2 description]);

    // Angle/Axis rep
    NSLog([NSString stringWithFormat:@"[Axis,angle]: %@",[[q angleAxisRepresentation] description]]);

    // Conjugated quaternion
    NSLog([NSString stringWithFormat:@"Conjugated quaternion: %@",[[q conjugatedQuaternion] description]]);

    // Inverted quaternion
    NSLog([NSString stringWithFormat:@"Inverted quaternion: %@",[[q invertedQuaternion] description]]);
  } 
  [pool release];
  exit(0);
}


